/******************************************************************************
*                                                                             *
* License Agreement                                                           *
*                                                                             *
* Copyright (c) 2003 Altera Corporation, San Jose, California, USA.           *
* All rights reserved.                                                        *
*                                                                             *
* Permission is hereby granted, free of charge, to any person obtaining a     *
* copy of this software and associated documentation files (the "Software"),  *
* to deal in the Software without restriction, including without limitation   *
* the rights to use, copy, modify, merge, publish, distribute, sublicense,    *
* and/or sell copies of the Software, and to permit persons to whom the       *
* Software is furnished to do so, subject to the following conditions:        *
*                                                                             *
* The above copyright notice and this permission notice shall be included in  *
* all copies or substantial portions of the Software.                         *
*                                                                             *
* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR  *
* IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,    *
* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE *
* AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER      *
* LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING     *
* FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER         *
* DEALINGS IN THE SOFTWARE.                                                   *
*                                                                             *
* This agreement shall be governed in all respects by the laws of the State   *
* of California and by the laws of the United States of America.              *
*                                                                             *
******************************************************************************/

#ifndef __ALTERA_AVALON_TIMER_REGS_H__
#define __ALTERA_AVALON_TIMER_REGS_H__

#include <rtems/score/alt_io.h>

#define IOADDR_ALTERA_AVALON_TIMER_STATUS(base)       __IO_CALC_ADDRESS_NATIVE(base, 0)
#define IORD_ALTERA_AVALON_TIMER_STATUS(base)         IORD(base, 0) 
#define IOWR_ALTERA_AVALON_TIMER_STATUS(base, data)   IOWR(base, 0, data)

#define ALTERA_AVALON_TIMER_STATUS_TO_MSK             (0x1)
#define ALTERA_AVALON_TIMER_STATUS_TO_OFST            (0)
#define ALTERA_AVALON_TIMER_STATUS_RUN_MSK            (0x2)
#define ALTERA_AVALON_TIMER_STATUS_RUN_OFST           (1)

#define IOADDR_ALTERA_AVALON_TIMER_CONTROL(base)      __IO_CALC_ADDRESS_NATIVE(base, 1)
#define IORD_ALTERA_AVALON_TIMER_CONTROL(base)        IORD(base, 1) 
#define IOWR_ALTERA_AVALON_TIMER_CONTROL(base, data)  IOWR(base, 1, data)

#define ALTERA_AVALON_TIMER_CONTROL_ITO_MSK           (0x1)
#define ALTERA_AVALON_TIMER_CONTROL_ITO_OFST          (0)
#define ALTERA_AVALON_TIMER_CONTROL_CONT_MSK          (0x2)
#define ALTERA_AVALON_TIMER_CONTROL_CONT_OFST         (1)
#define ALTERA_AVALON_TIMER_CONTROL_START_MSK         (0x4)
#define ALTERA_AVALON_TIMER_CONTROL_START_OFST        (2)
#define ALTERA_AVALON_TIMER_CONTROL_STOP_MSK          (0x8)
#define ALTERA_AVALON_TIMER_CONTROL_STOP_OFST         (3)

#define IOADDR_ALTERA_AVALON_TIMER_PERIODL(base)      __IO_CALC_ADDRESS_NATIVE(base, 2)
#define IORD_ALTERA_AVALON_TIMER_PERIODL(base)        IORD(base, 2) 
#define IOWR_ALTERA_AVALON_TIMER_PERIODL(base, data)  IOWR(base, 2, data)

#define ALTERA_AVALON_TIMER_PERIODL_MSK               (0xFFFF)
#define ALTERA_AVALON_TIMER_PERIODL_OFST              (0)

#define IOADDR_ALTERA_AVALON_TIMER_PERIODH(base)      __IO_CALC_ADDRESS_NATIVE(base, 3)
#define IORD_ALTERA_AVALON_TIMER_PERIODH(base)        IORD(base, 3) 
#define IOWR_ALTERA_AVALON_TIMER_PERIODH(base, data)  IOWR(base, 3, data)

#define ALTERA_AVALON_TIMER_PERIODH_MSK               (0xFFFF)
#define ALTERA_AVALON_TIMER_PERIODH_OFST              (0)

#define IOADDR_ALTERA_AVALON_TIMER_SNAPL(base)        __IO_CALC_ADDRESS_NATIVE(base, 4)
#define IORD_ALTERA_AVALON_TIMER_SNAPL(base)          IORD(base, 4) 
#define IOWR_ALTERA_AVALON_TIMER_SNAPL(base, data)    IOWR(base, 4, data)

#define ALTERA_AVALON_TIMER_SNAPL_MSK                 (0xFFFF)
#define ALTERA_AVALON_TIMER_SNAPL_OFST                (0)

#define IOADDR_ALTERA_AVALON_TIMER_SNAPH(base)        __IO_CALC_ADDRESS_NATIVE(base, 5)
#define IORD_ALTERA_AVALON_TIMER_SNAPH(base)          IORD(base, 5) 
#define IOWR_ALTERA_AVALON_TIMER_SNAPH(base, data)    IOWR(base, 5, data)

#define ALTERA_AVALON_TIMER_SNAPH_MSK                 (0xFFFF)
#define ALTERA_AVALON_TIMER_SNAPH_OFST                (0)

#endif /* __ALTERA_AVALON_TIMER_REGS_H__ */
